<?php

/**
 * Project: PSU - points system user (система баллов пользователя) <br />
 * File:    index.php
 * Description: Исполняемый файл <br />
 *
 * @author Maxim Seshuk <maxim.seshuk@gmail.com>
 * @version P1 (update 2) (January 4th, 2012)
 * @last update 04.01.12 13:25
 *
 */

header('Content-type: text/html; charset=utf-8');

$id       = $_REQUEST['id'];
$act      = $_REQUEST['act'];
$type     = $_REQUEST['type'];
$other_id = $_REQUEST['other_id'];
$more1    = $_REQUEST['more1'];
// Ассоциативный массив (array), который по умолчанию содержит данные переменных $_GET, $_POST и $_COOKIE

require_once('psu.class.php');
include('config.php');
include('function.php');
// Загрузка файлов

$users_file   = 'users.dat';
$cookie_file  = 'cookie.dat';
$history_file = 'history.dat';
// Файлы

if (!$uID AND $act != 'data')
    exit('Ошибка сервера');
// Зашёл пользователь на сайт или нет

if ($act == 'data' AND !$type) {
    $object1       = new PSU;
    $object1->file = $users_file;
    switch ($object1->Points($id, 0)) {
        case true:
            echo $object1->Points($id, 1);
            break;
        case false:
            echo 0;
            break;
    }
    exit;
}
// Вывод баллов пользователя

if ($act AND !$type) {
    $object2       = new PSU;
    $object2->file = $users_file;
    if (!$object2->Points($uID, 0)) {
        $object2->id     = $uID;
        $object2->points = 0;
        $object2->Creation();
    }
    
    $object2->file = file_get_contents('plugins/counting.xml');
    $act           = $object2->XML()->{'p' . $act};
    if (!is_file('plugins/' . $act . '/index.php'))
        exit('Ошибка сервера');
    if (!is_file('plugins/' . $act . '/settings.xml'))
        exit('settings.xml не найден');
    $plugin_name   = $act;
    $plugin_url    = "./plugins/$act";
    $object2       = new PSU;
    $object2->file = file_get_contents('plugins/' . $act . '/settings.xml');
    
    if (!get_bool((string) $object2->XML()->main->switch->{'item'}[0]))
        exit('Модуль выключен');
    require('plugins/' . $act . '/index.php');
    exit;
}
// Выполнение плагинов

if ($act == 'plugins' AND $type == 'list') {
    $dirs = dir_list('plugins');
    foreach ($dirs as $dir) {
        $object3       = new PSU;
        $object3->file = file_get_contents('plugins/' . $dir . '/settings.xml');
        if (!get_bool((string) $object3->XML()->main->switch->{'item'}[0])) {
            exit;
        } elseif (!get_bool((string) $object3->XML()->main->switch->{'item'}[1])) {
            exit;
        }
        $price = (get_bool((string) $object3->XML()->main->price->{'switch'})) ? ' &nbsp; (' . declOfNum($object3->XML()->main->price->{'price'}, array(
            'балл',
            'балла',
            'баллов'
        )) . ')' : '';
        echo "<div onmouseover=\"this.className='myPsuTblTD2'\" onmouseout=\"this.className=''\" onclick=\"psu_{$dir}.{$object3->XML()->main->main_js}()\" style=\"padding-left:5px; padding-bottom:10px; cursor:pointer;\"><div style=\"padding:5px 0;padding-left:10px;font-size:14px\"><b>{$object3->XML()->main->name}</b> $price</div>{$object3->XML()->main->description}</div>";
    }
    exit;
}
// Список плагинов для магазина

if ($act == 'plugins' AND $type == 'js') {
    header("Content-type: text/javascript; charset=utf-8");
    $dirs = dir_list('plugins');
    foreach ($dirs as $dir) {
        $object3       = new PSU;
        $object3->file = file_get_contents('plugins/' . $dir . '/settings.xml');
        if (!get_bool((string) $object3->XML()->main->switch->{'item'}[0])) {
            exit;
        } elseif (!get_bool((string) $object3->XML()->main->switch->{'item'}[1])) {
            exit;
        }
        if ($object3->XML()->main->{'variables'}) {
            include 'plugins/' . $dir . '/' . $object3->XML()->main->{'variables'};
        }
        if (get_bool((string) $object3->XML()->main->price->{'switch'})) {
            Variables('PRICE', $object3->XML()->main->price->{'price'});
        }
        Variables('PLUGIN', $dir, 'ID', $object3->XML()->main['id']);
        echo Variables('var psu_' . $dir . ' = {' . $object3->XML()->main->{'var_js'} . '}; ');
        $object3->file  = Variables(file_get_contents('plugins/' . $dir . '/settings.xml'));
        $object3->more1 = $dir;
        echo $object3->XMLScript();
    }
    exit;
}
// JS код плагинов

if ($act == 'data' AND $type == 'history') {
    preg_match_all("#$id{number\=(.*)\,message\=(.*)\,points\=(.*)\,timestamp\=(.*)\,operations\=(.*)}#isU", file_get_contents($history_file), $matches);
    if (count($matches[0]) == 0)
        exit('<div style="padding:20px; text-align: center;">История операций для данного пользователя пуста.</div>');
    for ($i = 0; $i <= count($matches[0]) - 1; $i++) {
        $level = (1 == $matches[5][$i]) ? 'увеличены' : 'вычитаны';
        $sign  = (1 == $matches[5][$i]) ? '' : '-';
        $name  = (1 == $matches[5][$i]) ? 'plus' : 'minus';
        echo "<div id=\"blr{$matches[1][$i]}\"><table border=\"0\" cellpadding=\"1\" cellspacing=\"1\" width=\"100%\">
<tbody><tr><td width=\"70%\"><div title=\"Баллы $level [{$sign}{$matches[3][$i]}]\" style=\"width:16px;height:17px;float:left;background: url('http://s1.ucoz.net/img/icon/$name.png') no-repeat 0 0\"></div> &nbsp; <a class=\"banHUser\" href=\"http://maxim-seshuk.ucoz.com/index/8-$id\" target=\"_blank\"><b>" . API(SITE_ADDRESS . 'api/index/8-' . $id, 'USER_USERNAME') . "</b></a></td><td align=\"right\" style=\"white-space: nowrap;font-size:7pt\">" . date('m.d.Y, H:i:s', $matches[4][$i]) . "</td></tr>
<tr><td colspan=\"2\"><div id=\"mmtx{$matches[1][$i]}\">{$matches[2][$i]}</div><div><span id=\"mmaxt{$matches[1][$i]}\"></span><i><span id=\"mmax{$matches[1][$i]}\"></span></i></div></td></tr></tbody></table><hr></div>";
    }
    exit;
}
// История операций

if ($act == 'data' AND $type == 'change' AND $id AND API(SITE_ADDRESS . 'api/index/8-' . $uID, 'USER_GROUPID') == 4) {
    $more1         = preg_replace("~[^0-9-]+~", "", $more1);
    $more1         = (!$more1 AND $more1 != 0) ? exit() : $more1;
    $object4       = new PSU;
    $object4->file = $users_file;
    if (!$object4->Points($id, 0)) {
        $object4->id     = $id;
        $object4->points = 0;
        $object4->Creation();
    }
    $file    = file_get_contents($users_file);
    $handle  = fopen($users_file, 'w');
    $content = preg_replace('/' . $id . '{points=(.*)}/si', $id . '{points=' . $more1 . '}', $file);
    if (fwrite($handle, $content)) {
        echo 1;
    } else {
        echo 0;
    }
    fclose($handle);
    exit;
}
// Измнение баллов для администраторов

echo "Ошибка сервера";
?>